unit Multii;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, Spin, StdCtrls, Buttons;

type
  TMainForm = class(TForm)
    Timer1: TTimer;
    PaintBox1: TPaintBox;
    Bevel1: TBevel;
    ADChanEd: TEdit;
    RateEd: TEdit;
    CancelBtn: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    ADChanSB: TSpinButton;
    PeriodSB: TSpinButton;
    ModeCB: TCheckBox;
    ErrorLab: TLabel;
    procedure Timer1Timer(Sender: TObject);
    procedure ADChanSBDownClick(Sender: TObject);
    procedure PeriodSBDownClick(Sender: TObject);
    procedure PeriodSBUpClick(Sender: TObject);
    procedure ADChanSBUpClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure PutVariables;
    procedure GetVariables;
    procedure PlotGraph;
  end;

var
  MainForm: TMainForm;

{------------------------------------------------------------------------}
implementation
Uses
   lcard_ad;

Var   Rate : Word; NChan:Integer;

{$R *.DFM}

procedure TMainForm.Timer1Timer(Sender: TObject);
begin
   PlotGraph;
end;

function Get16Colors(i:Integer):LongInt;
Var
   c:LongInt;
begin
   c:=0;
   if (i and 4)<>0 then c:=c+$FF0000;
   if (i and 2)<>0 then c:=c+$00FF00;
   if (i and 1)<>0 then c:=c+$0000FF;
   Get16Colors:=c;
end;

Const
   NPoint = 100;
procedure TMainForm.PlotGraph;
type
   TData = array [0..32766] of Integer;
Var
   pData          : ^TData;
   X0, Y0, X1, Y1 : Integer;
   i,j            : Integer;
   Max            : Real;
   Channels       : array [0..31] of Word;
begin
   GetVariables;
   getmem(pData, NPoint * NChan * 2);

   with PaintBox1 do
   begin
      X0:=0;
      X1:=BoundsRect.Right-BoundsRect.Left;
      Y0:=0;
      Y1:=BoundsRect.Bottom-BoundsRect.Top;

      {     : }
      {    1-iChan               }
      { !    0!!!            }
      for i:=0 to NChan-1 do
         Channels[i]:=CREATE_CHANNEL(i,0,0);


      {      }
      if ModeCB.State=cbChecked then
         begin
            {    DMA}
            DMAALL(pData^, NPoint, Channels,NChan,Rate,0);
            while DMA_TEST=0 do ;
            DMA_OFF;
         end
      else
         {     }
         SOFT(pData^, NPoint, Channels, NChan, Rate);

      Canvas.Pen.Color:=clYellow;
      Canvas.Brush.Color:=clNavy;
      Canvas.Rectangle(0,0,X1,Y1);

      Canvas.MoveTo(0,Y1 div 2);
      Canvas.LineTo(X1,Y1 div 2);

      Max:=1;
      for i:=0 to NChan-1 do
         for j:=0 to NPoint-1 do
            if Abs(pData^[j*NChan+i])>Max then
                Max:=Abs(pData^[j*NChan+i]);
      Max:=Max*1.2;


      for i:=0 to NChan-1 do
         begin
            Canvas.Pen.Color:=Get16Colors(i+18);
            Canvas.MoveTo(round(1/NPoint*X1), -round(pData^[i]/Max*Y1/2)+Y1 div 2);
            for j:=1 to NPoint-1 do
               Canvas.LineTo(round(j/NPoint*X1), -round(pData^[j*NChan+i]/Max*Y1/2)+Y1 div 2);
         end;
   end;
   freemem(pData, NPoint*2);
end;


procedure TMainForm.ADChanSBDownClick(Sender: TObject);
Var Err:Integer;
begin
   GetVariables;
   Dec(NChan);
   if NChan<1 then NChan:=1;
   PutVariables;
   PlotGraph;
end;

procedure TMainForm.ADChanSBUpClick(Sender: TObject);
Var Err:Integer;
begin
   GetVariables;
   Inc(NChan);
   PutVariables;
   PlotGraph;
end;

procedure TMainForm.PeriodSBDownClick(Sender: TObject);
Var Err:Integer;
begin
   GetVariables;
   Rate:=Rate - 10;
   if Rate<10 then Rate:=10;
   PutVariables;
   PlotGraph;
end;

procedure TMainForm.PeriodSBUpClick(Sender: TObject);
Var Err:Integer;
begin
   GetVariables;
   Rate:=Rate + 10;
   PutVariables;
   PlotGraph;
end;

procedure TMainForm.PutVariables;
begin
   AdChanEd.Text:=IntToStr(NChan);
   RateEd.Text:=IntToStr(Rate);
end;

procedure TMainForm.GetVariables;
Var
   Err:Boolean;
begin
   Err:=False;
   try
      NChan:=StrToInt(AdChanEd.Text);
      Rate:=StrToInt(RateEd.Text);
      if NChan<1 then NChan:=1;
      if NChan>31 then NChan:=31;
      if Rate<10 then Rate:=10;
   except
      on EConvertError do Err:=True;
      on ERangeError do Err:=True;
   end;
   ErrorLab.Visible:=Err;
end;



procedure TMainForm.CancelBtnClick(Sender: TObject);
begin
   Close;
end;

end.
